Fix a bug in cfg fixup
[official-gcc.git] / contrib / gcc_update
blobc368936e51e02ce6452c7e391fcfbbf48febca14
1 #! /bin/sh
3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009, 2010,
8 # 2011 Free Software Foundation
9 # Originally by Gerald Pfeifer <pfeifer@dbai.tuwien.ac.at>, August 1998.
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License. A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19 # are omitted.
21 # If the first parameter reads --patch, the second parameter is considered
22 # a patch file.
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
26 # will be touched.
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
34 # Examples:
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
42 # Default options used when updating (none).
43 UPDATE_OPTIONS=""
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
47 LANG=C
48 LC_ALL=C
49 export LANG LC_ALL
51 ######## Anything below shouldn't be changed by regular users.
53 # Arrange for the value of $0 to be available for functions
54 self=$0
56 # This function prints its arguments to standard output unless
57 # "silent" is set.
58 unset silent
59 chat () {
60 if [ -z "$silent" ]; then
61 echo "$@"
65 # This function prints a list of all generated files, along with their
66 # dependencies. Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies () {
69 sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70 # fixincludes
71 fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72 fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73 # intl library
74 intl/plural.c: intl/plural.y
75 intl/configure: intl/configure.ac intl/aclocal.m4
76 intl/config.h.in: intl/configure.ac intl/aclocal.m4
77 # Now, proceed to gcc automatically generated files
78 gcc/configure: gcc/configure.ac
79 gcc/cstamp-h.in: gcc/configure.ac
80 gcc/config.in: gcc/cstamp-h.in
81 gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
82 gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cores.def gcc/config/arm/gentune.sh
83 gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-arches.def gcc/config/arm/arm-cores.def gcc/config/arm/arm-fpus.def gcc/config/arm/genopt.sh
84 gcc/config/avr/avr-tables.opt: gcc/config/avr/avr-mcus.def gcc/config/avr/genopt.sh
85 gcc/config/c6x/c6x-tables.opt: gcc/config/c6x/c6x-isas.def gcc/config/c6x/genopt.sh
86 gcc/config/c6x/c6x-sched.md: gcc/config/c6x/c6x-sched.md.in gcc/config/c6x/gensched.sh
87 gcc/config/c6x/c6x-mult.md: gcc/config/c6x/c6x-mult.md.in gcc/config/c6x/genmult.sh
88 gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
89 gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
90 gcc/config/rs6000/rs6000-tables.opt: gcc/config/rs6000/rs6000-cpus.def gcc/config/rs6000/genopt.sh
91 # And then, language-specific files
92 gcc/cp/cfns.h: gcc/cp/cfns.gperf
93 gcc/java/keyword.h: gcc/java/keyword.gperf
94 # testsuite
95 # Without this, _Pragma3.c can have a false negative.
96 gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
97 # Similarly, without this, you will see:
98 # direct2s.c:35: warning: current file is older than direct2.c
99 gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
100 # lto-plugin
101 lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
102 lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
103 # And libraries, at last
104 libbanshee/configure: libbanshee/configure.ac
105 libmudflap/configure: libmudflap/configure.ac
106 libobjc/configure: libobjc/configure.ac
107 zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
108 zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
109 zlib/configure: zlib/configure.ac zlib/aclocal.m4
110 fastjar/aclocal.m4: fastjar/configure.ac
111 fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
112 fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
113 boehm-gc/aclocal.m4: boehm-gc/configure.ac
114 boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
115 boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
116 libada/configure: libada/configure.ac
117 libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
118 libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
119 libffi/configure: libffi/configure.ac libffi/aclocal.m4
120 libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
121 libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
122 libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
123 libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
124 libjava/aclocal.m4: libjava/configure.ac
125 libjava/Makefile.in: libjava/Makefile.am libjava/configure.ac libjava/aclocal.m4
126 libjava/configure: libjava/configure.ac libjava/aclocal.m4
127 libjava/libltdl/aclocal.m4: libjava/libltdl/configure.ac libjava/libltdl/acinclude.m4
128 libjava/libltdl/Makefile.in: libjava/libltdl/Makefile.am libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
129 libjava/libltdl/configure: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
130 libjava/libltdl/config-h.in: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
131 libcpp/aclocal.m4: libcpp/configure.ac
132 libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
133 libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
134 libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
135 libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
136 libgomp/testsuite/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
137 libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
138 libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
139 # Top level
140 Makefile.in: Makefile.tpl Makefile.def
141 configure: configure.ac config/acx.m4
146 # This function touches generated files such that the ``end'' user does
147 # not have to rebuild them.
148 touch_files () {
149 rm -f Makefile.$$
150 echo 'all: \' > Makefile.$$
151 files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
152 echo '; @true' >> Makefile.$$
153 files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
154 files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
155 echo ':' >> Makefile.$$
156 echo ' @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
157 echo ' echo Touching $@...; \' >> Makefile.$$
158 chat ' echo Touching $@... 1>&2; \' >> Makefile.$$
159 echo ' touch $@' >> Makefile.$$
160 files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
162 # We would have to explicitly shut off the "Entering... Leaving..."
163 # messages through "--no-print-directory" to handle the case when
164 # we were called from a recursive invocation (i.e. "$(MAKE)" in a
165 # Makefile, not just make). Passing only "-s" doesn't help then,
166 # because make has helpfully added "-w" to MAKEFLAGS automatically.
167 # Unfortunately we do not require GNU make other than for building
168 # and testing, so let's just grep known text explicitly echoed by
169 # the rule.
170 while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
171 sleep 1
172 done 2>&1
173 rm -f Makefile.$$
177 # Whenever we update the tree or install a patch, we may be modifying
178 # this script. By re-execing it, we ensure that the appropriate
179 # dependencies and rules will be used.
180 touch_files_reexec () {
181 chat "Adjusting file timestamps"
182 exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
185 # This functions applies a patch to an existing tree.
186 apply_patch () {
187 if [ -f "$1" ]; then
188 echo "Applying patch file $1"
189 case $1 in
190 *gz)
191 gzip -d -c "$1" | patch -p1 ;;
192 *bz2)
193 bzip2 -d -c "$1" | patch -p1 ;;
195 patch -p1 < "$1";;
196 esac
198 touch_files_reexec
201 # Check whether this indeed looks like a local tree.
202 if [ ! -f gcc/version.c ]; then
203 echo "This does not seem to be a GCC tree!"
204 exit
207 case "$1" in
208 --silent)
209 silent=t
210 shift
212 esac
214 case "$1" in
215 # First of all, check whether we are going to process a patch.
216 --patch)
217 if test "$#" != 2; then
218 echo "$1" expects only one argument >&2
219 exit 1
221 apply_patch "${2}"
222 exit $?
225 --touch)
226 if test "$#" != 1; then
227 echo "$1" does not expect any argument >&2
228 exit 1
230 touch_files
231 exit $?
234 --list)
235 if test "$#" != 1; then
236 echo "$1" does not expect any argument >&2
237 exit 1
239 files_and_dependencies | sed 's/ /: /'
240 exit $?
243 --help)
244 sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
248 }' \
249 -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
250 exit $?
253 esac
255 # Check for known version control systems.
256 if [ -d .git ]; then
257 GCC_GIT=${GCC_GIT-${GIT-git}}
258 vcs_type="git"
259 elif [ -d .hg ]; then
260 GCC_HG=${GCC_HG-${HG-hg}}
261 vcs_type="hg"
262 elif [ -d .svn ]; then
263 GCC_SVN=${GCC_SVN-${SVN-svn}}
264 vcs_type="svn"
265 else
266 echo "This does not seem to be a GCC GIT/HG/SVN tree!"
267 exit
270 # Check command-line options
271 if [ x"${1}"x = x"--nostdflags"x ]; then
272 shift
273 else
274 set -- $UPDATE_OPTIONS ${1+"$@"}
277 case $vcs_type in
278 git)
279 chat "Updating GIT tree"
281 $GCC_GIT diff --quiet --exit-code HEAD
282 if [ $? -ne 0 ]; then
283 echo "Attempting to update a dirty git tree!" >&2
284 echo "Commit or stash your changes first and retry." >&2
285 exit 1
288 $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
289 if [ $? -ne 0 ]; then
290 (touch_files_reexec)
291 echo "git pull of full tree failed." >&2
292 exit 1
295 revision=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
296 branch=`$GCC_GIT name-rev --name-only HEAD || :`
300 chat "Updating HG tree"
302 # Add -q so untracked files aren't listed.
303 if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
304 echo "Attempting to update a dirty hg tree!" >&2
305 echo "Commit or revert your changes first and retry." >&2
306 exit 1
309 # Check for mq extension. mq patches must be popped so tip has
310 # been converted from the SVN tree.
311 if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
312 # FIXME: Perhaps pop queue instead? We could do that since we
313 # know the tree is clean.
314 echo "Attempting to update hg tree with mq patches applied!" >&2
315 echo "Pop your patches first and retry." >&2
316 exit 1
319 # Update tree, but make sure to only pull the default branch.
320 # Otherwise all branches in the upstream repo are added, even if
321 # only a single one has been cloned.
322 $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
323 if [ $? -ne 0 ]; then
324 (touch_files_reexec)
325 echo "hg pull of full tree failed." >&2
326 exit 1
329 # Update tree. Needs to be done separately from pull so
330 # gcc_update -rREV works.
331 $GCC_HG update ${silent+-q} ${1+"$@"}
332 if [ $? -ne 0 ]; then
333 (touch_files_reexec)
334 echo "hg update of full tree failed." >&2
335 exit 1
338 # Extract SVN revision corresponding to parents, as stored by
339 # hg convert. Before hg 1.4.3, there's no template keyword
340 # corresponding to the extra: tag, so need to use hg log --debug
341 # to extract the info.
342 parents=`$GCC_HG parents --template '{rev}'`
343 revision=`$GCC_HG log --debug -r$parents | \
344 sed -ne "/^extra:.*convert_revision=svn:/ {
345 s%^.*@%%
348 branch=`$GCC_HG branch`
349 # trunk in SVN parlance shows up as default branch in hg.
350 [ x$branch = x"default" ] && branch="trunk"
353 svn)
354 chat "Updating SVN tree"
356 $GCC_SVN ${silent+-q} --non-interactive update ${1+"$@"}
357 if [ $? -ne 0 ]; then
358 (touch_files_reexec)
359 echo "SVN update of full tree failed." >&2
360 exit 1
363 revision=`svn info | awk '/Revision:/ { print $2 }'`
364 branch=`svn info | sed -ne "/URL:/ {
365 s,.*/trunk,trunk,
366 s,.*/branches/,,
367 s,.*/tags/,,
371 esac
373 rm -f LAST_UPDATED gcc/REVISION
375 date
376 echo "`TZ=UTC date` (revision $revision)"
377 } > LAST_UPDATED
378 echo "[$branch revision $revision]" > gcc/REVISION
380 touch_files_reexec